VERSION 5.00
Begin VB.Form FtpForm 
   Caption         =   "basicpro FTP Client"
   ClientHeight    =   5340
   ClientLeft      =   900
   ClientTop       =   1230
   ClientWidth     =   7560
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   5340
   ScaleWidth      =   7560
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4620
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   7335
   End
   Begin VB.TextBox T_Path 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7335
   End
   Begin VB.Menu menu_verbindung 
      Caption         =   "&Verbindung"
      Begin VB.Menu menu_connect 
         Caption         =   "&Verbindung mit Server herstellen"
      End
      Begin VB.Menu menu_disconnect 
         Caption         =   "Verbindung schlieen"
      End
      Begin VB.Menu menu_v1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_ende 
         Caption         =   "&Beenden"
      End
   End
   Begin VB.Menu menu_datei 
      Caption         =   "&Datei"
      Begin VB.Menu menu_get 
         Caption         =   "Datei vom Server laden (GET)"
      End
      Begin VB.Menu menu_reget 
         Caption         =   "Datei vom Server laden (REGET)"
      End
      Begin VB.Menu menu_put 
         Caption         =   "Datei auf den Server laden (PUT)"
      End
      Begin VB.Menu menu_d1 
         Caption         =   "-"
      End
      Begin VB.Menu menu_rename 
         Caption         =   "Datei umbenennen"
      End
      Begin VB.Menu menu_delete 
         Caption         =   "Datei lschen"
      End
      Begin VB.Menu menu_chmod 
         Caption         =   "Datei Zugriffsrechte ndern"
      End
   End
   Begin VB.Menu menu_verzeichnis 
      Caption         =   "Ver&zeichnis"
      Begin VB.Menu menu_mkdir 
         Caption         =   "Verzeichnis anlegen"
      End
      Begin VB.Menu menu_rmdir 
         Caption         =   "Verzeichnis lschen"
      End
   End
   Begin VB.Menu menu_option 
      Caption         =   "&Optionen"
      Begin VB.Menu menu_typeasc 
         Caption         =   "bertragung &ASCII"
      End
      Begin VB.Menu menu_typebin 
         Caption         =   "bertragung &BINR"
      End
   End
End
Attribute VB_Name = "FtpForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private WithEvents ftp As FtpClient
Attribute ftp.VB_VarHelpID = -1
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private pathHasFocus%
Private selectedFileName$
Private selectedFileType$

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

If KeyCode = 13 And pathHasFocus% = True And menu_connect.Enabled = False Then
   ShowDirectory
End If

End Sub

Private Sub Form_Load()

Set ftp = New FtpClient
FtpConnect.T_Server.Text = ini$("Server")
FtpConnect.T_User.Text = ini$("User")
FtpConnect.T_Password.Text = ini$("Password")
enable False

End Sub

Private Sub Form_Resize()

If Me.WindowState = 1 Then Exit Sub
T_Path.Width = Me.ScaleWidth - T_Path.Left - 120
If Me.ScaleWidth > 240 Then List1.Width = Me.ScaleWidth - 240
If Me.ScaleHeight - List1.Top > 120 Then List1.Height = Me.ScaleHeight - List1.Top - 120

End Sub

Private Sub Form_Unload(Cancel As Integer)

Unload FtpConnect

If menu_connect.Enabled = False Then ftp.Disconnect
Set ftp = Nothing

End Sub

Function ini$(key$)

Dim a As String * 255
l& = GetPrivateProfileString("FtpClient", key$, "", a$, 255, App.Path + "\config.ini")
ini$ = Left$(a$, l&)

End Function

Private Sub ftp_Closed()

enable False

End Sub

Private Sub List1_Click()

a$ = List1.Text
selectedFileType$ = Left$(a$, 1)
For n% = 1 To 9: a0$ = parse$(a$, " "): a$ = Trim$(a$): Next
selectedFileName$ = a0$

End Sub

Private Sub List1_DblClick()

If selectedFileType$ = "-" Then
   MsgBox ftp.GetString(selectedFileName$), , selectedFileName$
ElseIf selectedFileType$ = "d" Then
   T_Path.Text = T_Path.Text + "/" + selectedFileName$
   ShowDirectory
End If

End Sub

Private Sub menu_chmod_Click()

If selectedFileType$ <> "-" And selectedFileType$ <> "d" Then MsgBox "Bitte Datei markieren", 48, "Datei Zugriffsrechte ndern": Exit Sub
   
a$ = InputBox$("Neue Zugriffsrechte", "Datei Zugriffsrechte ndern")
If Len(a$) = 0 Then Exit Sub

If ftp.ChMod(selectedFileName$, Val(a$)) = False Then MsgBox ftp.LastError, 16, "Datei Zugriffsrechte ndern"
ShowDirectory

End Sub

Private Sub menu_connect_Click()

FtpConnect.Left = Me.Left + Me.Width / 2 - FtpConnect.Width / 2
FtpConnect.Top = Me.Top + Me.Height / 2 - FtpConnect.Height / 2
FtpConnect.Show 1
If FtpConnect.Tag <> "" Then
   T_Path.Text = ""
   ftp.Server = FtpConnect.T_Server.Text
   ftp.User = FtpConnect.T_User.Text
   ftp.Password = FtpConnect.T_Password.Text
   
   Screen.MousePointer = 11
   If ftp.Connect() Then
      ShowDirectory
      enable True
   Else
      List1.Clear: List1.AddItem ftp.LastError
   End If
   Screen.MousePointer = 0
End If

End Sub

Private Sub menu_delete_Click()

If selectedFileType$ <> "-" Then MsgBox "Bitte Datei markieren", 48, "Datei lschen": Exit Sub
   
If ftp.Delete(selectedFileName$) = False Then MsgBox ftp.LastError, 16, "Datei lschen"
ShowDirectory

End Sub

Private Sub menu_disconnect_Click()

ftp.Disconnect
enable False

End Sub

Private Sub menu_ende_Click()

Unload Me

End Sub

Private Sub menu_get_Click()

If selectedFileType$ <> "-" Then MsgBox "Bitte Datei markieren", 48, "Datei vom Server laden (GET)": Exit Sub
   
p$ = CurDir$: a$ = Dialog_Save$(Me, "Datei vom Server laden (GET)", p$, selectedFileName$, "Alle Dateien|*.*", "txt")
If Len(a$) = 0 Then Exit Sub

Screen.MousePointer = 11
If ftp.GetFile(selectedFileName$, p$ + a$) = False Then MsgBox ftp.LastError, 16, "Datei vom Server laden (GET)"
Screen.MousePointer = 0

End Sub

Private Sub menu_mkdir_Click()

D$ = InputBox$("Verzeichnis-Name", "Verzeichnis anlegen")
If Len(D$) = 0 Then Exit Sub

If ftp.MkDir(D$) = False Then MsgBox ftp.LastError, 16, "Verzeichnis anlegen"
ShowDirectory

End Sub

Private Sub menu_put_Click()

p$ = CurDir$: a$ = Dialog_Open$(Me, "Datei auf den Server laden (PUT)", p$, selectedFileName$, "Alle Dateien|*.*", "txt")
If Len(a$) = 0 Then Exit Sub

Screen.MousePointer = 11
If ftp.PutFile(p$ + a$, a$) = False Then MsgBox ftp.LastError, 16, "Datei auf den Server laden (PUT)"
Screen.MousePointer = 0

ShowDirectory

End Sub

Private Sub menu_reget_Click()

If selectedFileType$ <> "-" Then MsgBox "Bitte Datei markieren", 48, "Datei vom Server laden (REGET)": Exit Sub
   
p$ = CurDir$: a$ = Dialog_Open$(Me, "Datei vom Server laden (REGET)", p$, selectedFileName$, "Alle Dateien|*.*", "txt")
If Len(a$) = 0 Then Exit Sub

Screen.MousePointer = 11
If ftp.ReGetFile(selectedFileName$, p$ + a$) = False Then MsgBox ftp.LastError, 16, "Datei vom Server laden (REGET)"
Screen.MousePointer = 0

End Sub

Private Sub menu_rename_Click()

If selectedFileType$ <> "-" Then MsgBox "Bitte Datei markieren", 48, "Datei umbenennen": Exit Sub
   
a$ = InputBox$("Neuer Name", "Datei umbenennen", selectedFileName$)
If Len(a$) = 0 Or a$ = selectedFileName$ Then Exit Sub

If ftp.Rename(selectedFileName$, a$) = False Then MsgBox ftp.LastError, 16, "Datei umbenennen"
ShowDirectory

End Sub

Private Sub menu_rmdir_Click()

If selectedFileType$ <> "d" Then MsgBox "Bitte Verzeichnis markieren", 48, "Verzeichnis lschen": Exit Sub

If ftp.RmDir(selectedFileName$) = False Then MsgBox ftp.LastError, 16, "Verzeichnis lschen"
ShowDirectory

End Sub

Private Sub menu_typeasc_Click()

ftp.Transfer = transferAscii
enable True

End Sub

Private Sub menu_typebin_Click()

ftp.Transfer = transferBinary
enable True

End Sub

Private Sub T_Path_GotFocus()

pathHasFocus% = True

End Sub

Private Sub T_Path_LostFocus()

pathHasFocus% = False

End Sub

Private Function parse$(a$, ch$)
ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If
End Function

Sub ShowDirectory()

If Len(T_Path.Text) Then ftp.CurDir = T_Path.Text
T_Path.Text = ftp.CurDir
Screen.MousePointer = 11
List1.Clear: a$ = ftp.Dir(): Do While Len(a$): List1.AddItem parse$(a$, vbCrLf): Loop
Screen.MousePointer = 0
selectedFileName$ = ""
selectedFileType$ = ""

End Sub

Sub enable(flg%)

menu_connect.Enabled = Not flg%
menu_disconnect.Enabled = flg%
menu_mkdir.Enabled = flg%
menu_rmdir.Enabled = flg%
menu_typebin.Enabled = flg%
menu_typeasc.Enabled = flg%
menu_typeasc.Checked = flg% <> 0 And ftp.Transfer = transferAscii
menu_typebin.Checked = flg% <> 0 And ftp.Transfer = transferBinary
menu_get.Enabled = flg%
menu_reget.Enabled = flg%
menu_put.Enabled = flg%
menu_rename.Enabled = flg%
menu_delete.Enabled = flg%
menu_chmod.Enabled = flg%
T_Path.Enabled = flg%
List1.Enabled = flg%
Me.Caption = "basicpro FTP Client" + IIf(flg%, " - " + ftp.Server, "")

End Sub
